using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using J2EE.Naming;
using J2EE.Rmi;
using forumBeans;

namespace JanevaDemo
{
	/// <summary>
	/// Summary description for WinForm.
	/// </summary>
	public class WinForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button buttonConnect;

		private InitialContext mInitCtx;
		private System.Windows.Forms.ListBox usersListBox;
		private System.Windows.Forms.Button buttonShowUsers;

		public WinForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose (bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.buttonConnect = new System.Windows.Forms.Button();
			this.usersListBox = new System.Windows.Forms.ListBox();
			this.buttonShowUsers = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// buttonConnect
			// 
			this.buttonConnect.Location = new System.Drawing.Point(8, 184);
			this.buttonConnect.Name = "buttonConnect";
			this.buttonConnect.Size = new System.Drawing.Size(88, 32);
			this.buttonConnect.TabIndex = 0;
			this.buttonConnect.Text = "Connect";
			this.buttonConnect.Click += new System.EventHandler(this.buttonConnect_Click);
			// 
			// usersListBox
			// 
			this.usersListBox.Location = new System.Drawing.Point(8, 8);
			this.usersListBox.Name = "usersListBox";
			this.usersListBox.Size = new System.Drawing.Size(192, 160);
			this.usersListBox.TabIndex = 1;
			// 
			// buttonShowUsers
			// 
			this.buttonShowUsers.Location = new System.Drawing.Point(112, 184);
			this.buttonShowUsers.Name = "buttonShowUsers";
			this.buttonShowUsers.Size = new System.Drawing.Size(88, 32);
			this.buttonShowUsers.TabIndex = 2;
			this.buttonShowUsers.Text = "Show users";
			this.buttonShowUsers.Click += new System.EventHandler(this.buttonShowUsers_Click);
			// 
			// WinForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(496, 229);
			this.Controls.Add(this.buttonShowUsers);
			this.Controls.Add(this.usersListBox);
			this.Controls.Add(this.buttonConnect);
			this.Name = "WinForm";
			this.Text = "WinForm";
			this.ResumeLayout(false);
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.Run(new WinForm());
		}

		private void buttonConnect_Click(object sender, System.EventArgs e)
		{
			try {
				string[] initialContextParams = new String[]
				{
//					"-ORBInitRef",
//					"NameService=corbaloc::127.0.0.1:1416/NameService",
					"-vbroker.agent.port 14000"
				};
				mInitCtx = new InitialContext(initialContextParams);
				MessageBox.Show("Successfully connected to CORBA server.");
			}
			catch (Exception ex) {
				MessageBox.Show("Error: " + ex.Message);
			}
		}
		
		private void buttonShowUsers_Click(object sender, System.EventArgs e)
		{
			object userHomeObj = mInitCtx.Lookup("ejb/forum/UserEJB");
			UserHome userHome = (UserHome) PortableRemoteObject.Narrow(
				userHomeObj, typeof(UserHome));

			usersListBox.Items.Clear();
			ICollection users = userHome.FindAll();
			foreach (Object userObj in users) {
				User user = (User) PortableRemoteObject.Narrow(
					userObj, typeof(User));
				String login = user.GetLogin();
				String fullName = user.GetFullName();
				usersListBox.Items.Add(login + " - " + fullName);
			}
		}

	}
}
