using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

//using J2EE.Naming;
using J2EE.Rmi;
using forumBeans;

namespace JanevaDemo
{
	/// <summary>
	/// Summary description for WinForm.
	/// </summary>
	public class WinForm : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.Button buttonConnect;

		private InitialContext mInitCtx;
		private System.Windows.Forms.ListBox usersListBox;
		private System.Windows.Forms.Button buttonShowUsers;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TextBox textBoxSubject;
		private System.Windows.Forms.TextBox textBoxMessage;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Button button1;

		public WinForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose (bool disposing)
		{
			if (disposing)
			{
				if (components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.buttonConnect = new System.Windows.Forms.Button();
			this.usersListBox = new System.Windows.Forms.ListBox();
			this.buttonShowUsers = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.textBoxSubject = new System.Windows.Forms.TextBox();
			this.textBoxMessage = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.button1 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// buttonConnect
			// 
			this.buttonConnect.Location = new System.Drawing.Point(8, 184);
			this.buttonConnect.Name = "buttonConnect";
			this.buttonConnect.Size = new System.Drawing.Size(88, 32);
			this.buttonConnect.TabIndex = 0;
			this.buttonConnect.Text = "Connect";
			this.buttonConnect.Click += new System.EventHandler(this.buttonConnect_Click);
			// 
			// usersListBox
			// 
			this.usersListBox.Location = new System.Drawing.Point(8, 8);
			this.usersListBox.Name = "usersListBox";
			this.usersListBox.Size = new System.Drawing.Size(192, 160);
			this.usersListBox.TabIndex = 1;
			// 
			// buttonShowUsers
			// 
			this.buttonShowUsers.Location = new System.Drawing.Point(112, 184);
			this.buttonShowUsers.Name = "buttonShowUsers";
			this.buttonShowUsers.Size = new System.Drawing.Size(88, 32);
			this.buttonShowUsers.TabIndex = 2;
			this.buttonShowUsers.Text = "Show users";
			this.buttonShowUsers.Click += new System.EventHandler(this.buttonShowUsers_Click);
			// 
			// label1
			//
			this.label1.Location = new System.Drawing.Point(216, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(100, 16);
			this.label1.TabIndex = 3;
			this.label1.Text = "Subject:";
			// 
			// textBoxSubject
			// 
			this.textBoxSubject.Location = new System.Drawing.Point(216, 32);
			this.textBoxSubject.Name = "textBoxSubject";
			this.textBoxSubject.Size = new System.Drawing.Size(264, 20);
			this.textBoxSubject.TabIndex = 4;
			this.textBoxSubject.Text = "";
			// 
			// textBoxMessage
			// 
			this.textBoxMessage.Location = new System.Drawing.Point(216, 88);
			this.textBoxMessage.Name = "textBoxMessage";
			this.textBoxMessage.Size = new System.Drawing.Size(264, 20);
			this.textBoxMessage.TabIndex = 6;
			this.textBoxMessage.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(216, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(100, 16);
			this.label2.TabIndex = 5;
			this.label2.Text = "Message:";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(288, 128);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(112, 32);
			this.button1.TabIndex = 7;
			this.button1.Text = "Post message";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// WinForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(496, 229);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.textBoxMessage);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.textBoxSubject);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.buttonShowUsers);
			this.Controls.Add(this.usersListBox);
			this.Controls.Add(this.buttonConnect);
			this.Name = "WinForm";
			this.Text = "WinForm";
			this.ResumeLayout(false);
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main()
		{
			Application.Run(new WinForm());
		}

		private void buttonConnect_Click(object sender, System.EventArgs e)
		{
			try {
				string[] initialContextParams = new String[]
				{
//					"-ORBInitRef",
//					"NameService=corbaloc::127.0.0.1:1416/NameService",
					"-vbroker.agent.port 14000"
				};
				mInitCtx = new InitialContext(initialContextParams);
				MessageBox.Show("Successfully connected to CORBA server.");
			}
			catch (Exception ex) {
				MessageBox.Show("Error: " + ex.Message);
			}
		}

		private void buttonShowUsers_Click(object sender, System.EventArgs e)
		{
			usersListBox.Items.Clear();

			UserHome userHome = GetUserHome();
			ICollection users = userHome.FindAll();
			foreach (Object userObj in users) {
				User user = (User) PortableRemoteObject.Narrow(
					userObj, typeof(User));
				String login = user.GetLogin();
				usersListBox.Items.Add(login);
			}
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			try {
				UserHome userHome = GetUserHome();
				string userLogin = usersListBox.Text;
				User user = userHome.FindByLogin(userLogin);

				string subject = textBoxSubject.Text;
				string message = textBoxMessage.Text;
				ForumMessageHome forumMessageHome = GetForumMessageHome();
				forumMessageHome.Create(user, subject, message);

				MessageBox.Show("Message posted!");
			} catch (Exception ex) {
				MessageBox.Show("Error: " + ex.Message);
			}
		}

		private UserHome GetUserHome()
		{
			object userHomeObj = mInitCtx.Lookup("ejb/forum/UserEJB");
			UserHome userHome = (UserHome) PortableRemoteObject.Narrow(
				userHomeObj, typeof(UserHome));
			return userHome;
		}

		private ForumMessageHome GetForumMessageHome()
		{
			object forumMessageHomeObj = mInitCtx.Lookup("ejb/forum/ForumMessageEJB");
			ForumMessageHome forumMessageHome =
				(ForumMessageHome) PortableRemoteObject.Narrow(
					forumMessageHomeObj, typeof(ForumMessageHome));
			return forumMessageHome;
		}

	}
}
