package presentationLogic;

import forumBeans.UserHome;
import forumBeans.User;
import forumBeans.ForumMessage;
import forumBeans.ForumMessageHome;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.rmi.PortableRemoteObject;
import javax.ejb.FinderException;
import java.rmi.RemoteException;
import java.util.Collection;


public class CommonUtils {

    public static final String USER_EJB_JNDI_NAME = "ejb/forum/UserEJB";
    public static final String FORUM_MESSAGE_EJB_JNDI_NAME = "ejb/forum/ForumMessageEJB";

    public static boolean isAccountValid(String aLogin, String aPassword)
            throws NamingException, RemoteException {
        UserHome userHome = getUserHome();
        try {
            User user = userHome.findByLogin(aLogin);
            String userRealPassword = user.getPassword();
            boolean passwordValid = ((userRealPassword != null) &&
                    (userRealPassword.equals(aPassword)));
            return passwordValid;
        } catch (FinderException fe) {
            // User not found in database
            return false;
        }
    }

    public static void postNewMessage(String aLogin, String aSubject,
            String aBody) throws Exception {
        ForumMessageHome forumMessageHome = getForumMessageHome();
        UserHome userHome = getUserHome();
        User user = userHome.findByLogin(aLogin);
        forumMessageHome.create(user, aSubject, aBody);
    }

    public static ForumMessage[] getAllForumMessages() throws Exception {
        ForumMessageHome forumMessageHome = getForumMessageHome();
        Collection forumMessagesCollection = forumMessageHome.findAll();
        ForumMessage[] messages = (ForumMessage[])
                forumMessagesCollection.toArray(new ForumMessage[]{});
        return messages;
    }

    public static UserHome getUserHome() throws NamingException {
        InitialContext ctx = new InitialContext();
        UserHome userHome = (UserHome)PortableRemoteObject.narrow(
                ctx.lookup(USER_EJB_JNDI_NAME), UserHome.class);
        return userHome;
    }

    public static ForumMessageHome getForumMessageHome() throws NamingException {
        InitialContext ctx = new InitialContext();
        ForumMessageHome forumMessageHome = (ForumMessageHome)PortableRemoteObject.narrow(
                ctx.lookup(FORUM_MESSAGE_EJB_JNDI_NAME), ForumMessageHome.class);
        return forumMessageHome;
    }

}
